# $1 -> /home/username (where to install)
# $2 -> /home/username/MPlayer (where to compile)
# $3 -> /c/Install/MPlayer/MPlayer-1.0rc3/packages (where are packages)
# $4 -> /c/Install/MPlayer/MPlayer-1.0rc3/patches (where are patches)

mkdir $1/bin
mkdir $1/lib
mkdir $1/include
mkdir $1/man
mkdir $1/man/man1
mkdir $1/man/man3

export PATH="$PATH:$1/bin"
export CPPFLAGS="$CPPFLAGS -I$1/include"
export LDFLAGS="$LDFLAGS -L$1/lib"

# DirectX headers
# http://www.mplayerhq.hu/MPlayer/contrib/win32/
cd $1/include
tar -xvzf $3/dx7headers.tgz

# http://www.info-zip.org/UnZip.html#Downloads
# ftp://tug.ctan.org/tex-archive/tools/zip/info-zip/WIN32/unz552xN.exe
cp $3/unzip.exe $1/bin

# MinGW with enabled 64 bit file access
# http://oss.netfarm.it/mplayer-win32.php
# http://oss.netfarm.it/mplayer/misc/file64_mingw.diff
cd /mingw
patch -p1 < $4/file64_mingw.diff

cd $2

# http://www.gnu.org/software/libiconv/
tar -xvzf $3/libiconv-1.13.tar.gz
cd "libiconv-1.13"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://pkg-config.freedesktop.org/wiki/
tar -xvzf $3/pkg-config-0.23.tar.gz
cd pkg-config-0.23
patch -p1 < $4/pkg-config-0.23.diff
# glib
cd glib-1.2.10
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include  --disable-threads
make
make install
cp glib.h glibconfig.h $1/include
cp .libs/*.* $1/lib
#pkg-config
cd ..
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

export PKG_CONFIG_PATH="$PKG_CONFIG_PATH:$1/lib/pkgconfig/"

cd $2

# http://sourceware.org/pthreads-win32/announcement.html
# ftp://sources.redhat.com/pub/pthreads-win32
tar -xvzf $3/pthreads-w32-2-8-0-release.tar.gz
cd "pthreads-w32-2-8-0-release"
# http://ffmpeg.arrozcru.org/wiki/images/1/12/Pthreads-w32-2-8-0.diff
patch -p1 < $4/Pthreads-w32-2-8-0.diff
make clean GC-static
cp libpthreadGC2.a $1/lib
cp pthread.h sched.h $1/include/

cd $2

# http://sourceforge.net/projects/nasm/
# http://sourceforge.net/project/showfiles.php?group_id=6208
tar -xvjf $3/nasm-2.06rc10.tar.bz2
cd "nasm-2.06rc10"
./configure --prefix=$1
make
make install

cd $2 

# http://www.tortall.net/projects/yasm/
# http://www.tortall.net/projects/yasm/wiki/Download
tar -xvzf $3/yasm-0.8.0.tar.gz
cd "yasm-0.8.0"
./configure --prefix=$1
make
make install

cd $2 

# http://www.zlib.net/
tar -xvjf $3/zlib-1.2.3.tar.bz2
cd "zlib-1.2.3"
./configure --prefix=$1
make
make install

cd $2

# http://www.bzip.org/index.html
# http://www.bzip.org/downloads.html
tar -xvzf $3/bzip2-1.0.5.tar.gz
cd "bzip2-1.0.5"
patch -p1 < $4/bzip2-1.0.5.diff
make
make install PREFIX=$1

cd $2

# http://www.videolan.org/developers/libdca.html
# http://www.freshports.org/multimedia/libdts/
tar -xvjf $3/libdca-0.0.5.tar.bz2
cd "libdca-0.0.5"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2

# http://www.underbit.com/products/mad/
# ftp://ftp.mars.org/pub/mpeg/
tar -xvzf $3/libmad-0.15.1b.tar.gz
cd "libmad-0.15.1b"
# patch in case of gcc4.3
# patch -p1 < $4/libmad-0.15.1b.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2

# http://www.oberhumer.com/opensource/lzo/download/
# http://www.oberhumer.com/opensource/lzo/download/LZO-v1/
tar -xvzf $3/lzo-2.03.tar.gz
cd "lzo-2.03"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2

# http://sourceforge.net/projects/faac
# http://sourceforge.net/project/showfiles.php?group_id=704
tar -xvjf $3/faac-1.28.tar.bz2
cd "faac-1.28"
./bootstrap
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include --without-mp4v2
make
make install

cd $2

# http://sourceforge.net/projects/faac
# http://sourceforge.net/project/showfiles.php?group_id=704
tar -xvjf $3/faad2-2.7.tar.bz2
cd "faad2-2.7"
patch -p1 < $4/faad2-2.7-gcc3.4.5.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2
# http://www.musepack.net/index.php?pg=src
tar -xvjf $3/libmpcdec-1.2.6.tar.bz2
cd "libmpcdec-1.2.6"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install
# Some header files are not copied
cp include/mpcdec/*.h $1/include/mpcdec

cd $2 

# http://downloads.xiph.org/releases/ogg/
tar -xvzf $3/libogg-1.1.4rc1.tar.gz
cd "libogg-1.1.4rc1"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://downloads.xiph.org/releases/vorbis/
tar -xvjf $3/libvorbis-1.2.2rc1.tar.bz2
cd "libvorbis-1.2.2rc1"
patch -p1 < $4/libvorbis-1.2.2rc1-pthreadGC2.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include CFLAGS=-DPTW32_STATIC_LIB
make
make install

cd $2

# http://www.libsdl.org/download-1.2.php
tar -xvzf $3/SDL-1.2.13.tar.gz
cd "SDL-1.2.13"
patch -p1 < $4/SDL-1.2.13.diff
./configure --prefix=$1 --disable-shared
make
make install

cd $2

# http://downloads.xiph.org/releases/theora/
tar -xvjf $3/libtheora-1.1alpha2.tar.bz2
cd "libtheora-1.1alpha2"
./configure --prefix=$1 --disable-shared
make
make install

cd $2

# http://www.speex.org/downloads/
tar -xvzf $3/speex-1.2rc1.tar.gz
cd "speex-1.2rc1"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://sourceforge.net/projects/freetype/
# http://sourceforge.net/project/showfiles.php?group_id=3157
tar -xvjf $3/freetype-2.3.9.tar.bz2
cd "freetype-2.3.9"
./configure --prefix=$1 --disable-shared
make
make install
# error appear but do not take care

cd $2 

# http://sourceforge.net/projects/libpng/
# http://sourceforge.net/project/showfiles.php?group_id=5624
tar -xvjf $3/libpng-1.2.37.tar.bz2
cd "libpng-1.2.37"
./configure --prefix=$1 --disable-shared
make
make install

cd $2 

# http://www.littlecms.com/
# http://www.littlecms.com/downloads.htm
tar -xvzf $3/lcms-1.18a.tar.gz
cd "lcms-1.18"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://www.ijg.org/
# ftp://ftp.uu.net/graphics/jpeg/
tar -xvzf $3/jpegsrc.v6b.tar.gz
cd "jpeg-6b"
./configure --prefix=$1 --enable-static --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install
cp .libs/libjpeg.a $1/lib/
cp jpeglib.h jconfig.h jmorecfg.h $1/include/

cd $2 

# http://www.libpng.org/pub/mng/
# http://www.libpng.com/
# http://www.libmng.com/download.html?cat=25
tar -xvjf $3/libmng-1.0.10.tar.bz2
cd "libmng-1.0.10"
cp makefiles/makefile.mingw Makefile
patch -p1 < $4/libmng-1.0.10.diff
make
make install INSTALL_PREFIX=$1/

cd $2 

# http://sourceforge.net/projects/giflib/
tar -xvjf $3/libungif-4.1.4.tar.bz2
cd "libungif-4.1.4"
patch -p1 < $4/libungif-4.1.4.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://lame.sourceforge.net/download/download.html
# http://sourceforge.net/project/showfiles.php?group_id=290
tar -xvzf  $3/lame-398-2.tar.gz
cd "lame-398-2"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://www.twolame.org/
# http://sourceforge.net/project/showfiles.php?group_id=136040
tar -xvzf $3/twolame-0.3.12.tar.gz
cd "twolame-0.3.12"
# MPlayer has problems with non standard CFLAGS 
# export CFLAGS="$CFLAGS -DLIBTWOLAME_STATIC"
export CPPFLAGS="$CPPFLAGS -DLIBTWOLAME_STATIC"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://www.xvid.org/downloads.html
tar -xvzf $3/xvidcore-1.2.2.tar.gz
cd "xvidcore"
patch -p1 < $4/xvidcore-1.2.2-pthreadGC2.diff
cd "build/generic"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install
mv $1/lib/xvidcore.a $1/lib/libxvidcore.a

cd $2 

# http://www.videolan.org/developers/x264.html
# ftp://ftp.videolan.org/pub/videolan/x264/snapshots/
tar -xvjf $3/x264-snapshot-20090604-2245.tar.bz2
cd "x264-snapshot-20090604-2245"
./configure --prefix=$1 --extra-cflags="-I$1/include" --extra-ldflags="-L$1/lib"
make
make install

cd $2 

# http://www.live555.com/liveMedia/
# http://www.live555.com/liveMedia/public/
tar -xvzf $3/live.2009.06.02.tar.gz
cd "live"
genMakefiles mingw
make CC=gcc
cd ..
cp -R live $1/lib

cd $2

# http://caca.zoy.org/wiki/libcaca
tar -xvzf $3/libcaca-0.99.beta16.tar.gz
cd libcaca-0.99.beta16
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2

# http://fribidi.freedesktop.org/
tar -xvzf $3/fribidi-0.19.2.tar.gz
cd fribidi-0.19.2
patch -p1 < $4/fribidi-0.19.2.diff
./configure --prefix=$1 --disable-shared
make
make install

cd $2

# http://www.gnu.org/software/libcdio/
# http://ftp.gnu.org/gnu/libcdio/
tar -xvzf $3/libcdio-0.81.tar.gz
cd libcdio-0.81
patch -p1 < $4/libcdio-0.81.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2

# http://libdv.sourceforge.net/
# http://sourceforge.net/project/showfiles.php?group_id=4393
tar -xvzf $3/libdv-1.0.0.tar.gz
cd "libdv-1.0.0"
patch -p1 < $4/libdv-1.0.0.diff
patch -p1 < $4/libdv-1.0.0-pthreadGC2.diff
./configure  --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include --disable-gtk --disable-asm CFLAGS=-DPTW32_STATIC_LIB
make
make install

cd $2

# http://www.penguin.cz/~utx/amr
# http://www.3gpp.org/ftp/Specs/html-info/26073.htm
# http://www.3gpp.org/ftp/Specs/html-info/26104.htm
# http://www.3gpp.org/ftp/Specs/html-info/26204.htm
tar -xvjf $3/amrnb-7.0.0.2.tar.bz2
cd "amrnb-7.0.0.2"
# http://www.3gpp.org/ftp/Specs/html-info/26104.htm
cp $3/amr/26104-800.zip .
patch -p1 < $4/amrnb-7.0.0.2.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://www.penguin.cz/~utx/amr
# http://www.3gpp.org/ftp/Specs/html-info/26073.htm
# http://www.3gpp.org/ftp/Specs/html-info/26104.htm
# http://www.3gpp.org/ftp/Specs/html-info/26204.htm
tar -xvjf $3/amrwb-7.0.0.3.tar.bz2
cd "amrwb-7.0.0.3"
# http://www.3gpp.org/ftp/Specs/html-info/26204.htm
cp $3/amr/26204-800.zip .
patch -p1 < $4/amrwb-7.0.0.3.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://www.nut-container.org/
# http://wiki.multimedia.cx/index.php?title=NUT
# svn checkout svn://svn.mplayerhq.hu/nut/src/trunk nut
# archive is self made
tar -xvjf $3/nut-r662.tar.bz2
cd "nut"
patch -p1 < $4/nut-r662.diff
make
cp libnut/libnut.h $1/include
cp libnut/libnut.a $1/lib

cd $2 

# http://diracvideo.org/
# http://diracvideo.org/download/dirac-research/
tar -xvzf $3/dirac-1.0.2.tar.gz
cd "dirac-1.0.2"
./configure --prefix=$1 --disable-shared
make
make install

cd $2 

# http://liboil.freedesktop.org/wiki/
# http://liboil.freedesktop.org/download/
tar -xvzf $3/liboil-0.3.16.tar.gz
cd "liboil-0.3.16"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://diracvideo.org/
# http://diracvideo.org/download/schroedinger/
tar -xvzf $3/schroedinger-1.0.7.tar.gz
cd "schroedinger-1.0.7"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://expat.sourceforge.net/
# http://sourceforge.net/project/showfiles.php?group_id=10127&package_id=10780
tar -xvzf $3/expat-2.0.1.tar.gz
cd "expat-2.0.1"
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://fontconfig.org/wiki/
# http://fontconfig.org/release/
tar -xvzf $3/fontconfig-2.6.0.tar.gz
cd "fontconfig-2.6.0"
patch -p1 < $4/fontconfig-2.6.0.diff
# http://oss.netfarm.it/mplayer/misc/fontconfig-2.6.0-mplayer-fconfdir.diff
patch -p1 < $4/fontconfig-2.6.0-mplayer-fconfdir.diff
# http://oss.netfarm.it/mplayer/misc/fontconfig-2.6.0-cachedir.diff
patch -p1 < $4/fontconfig-2.6.0-cachedir.diff
# http://oss.netfarm.it/mplayer/misc/fontconfig-2.6.0-fix-dst.diff
patch -p1 < $4/fontconfig-2.6.0-fix-dst.diff
./configure --prefix=$1 --disable-shared --with-extralibdir=$1/lib --with-extraincdir=$1/include
make
make install

cd $2 

# http://www1.mplayerhq.hu/MPlayer/releases/
# svn checkout svn://svn.mplayerhq.hu/mplayer/branches/1.0rc3 mplayer-1.0rc3
# archive is self made
tar -xvjf $3/mplayer-1.0rc3-r29350.tar.bz2
cd "mplayer-1.0rc3"
# http://oss.netfarm.it/mplayer/patches/xx_pthread_static.diff
patch -p1 < $4/xx_pthread_static.diff
# http://oss.netfarm.it/mplayer/patches/xx_fontconfig_check.diff
patch -p1 < $4/xx_fontconfig_check.diff
patch -p1 < $4/mplayer_dvdnav_fix.diff
# http://oss.netfarm.it/mplayer/patches/xx_fontconfig_noconf_nocrash.diff
patch -p1 < $4/xx_fontconfig_noconf_nocrash.diff
# http://oss.netfarm.it/mplayer/patches/xx_fontconfig_verbosecache.diff
patch -p1 < $4/xx_fontconfig_verbosecache.diff
# http://lists.mplayerhq.hu/pipermail/mplayer-dev-eng/2009-April/061423.html
patch -p0 < $4/sdl.patch
patch -p1 < $4/mplayer-SDL.diff
patch -p1 < $4/mplayer-dhahelperwin.diff
./configure --prefix=$1 --extra-cflags="-fno-common" --enable-static --enable-mng --disable-tremor-internal --disable-faad-internal --enable-caca --with-fribidi-config="pkg-config fribidi"
make
make dhahelperwin
make install

cd $2 

# http://user.cs.tu-berlin.de/~jutta/toast.html
tar -xvzf $3/gsm-1.0.13.tar.gz
cd "gsm-1.0-pl13"
patch -p1 < $4/gsm-1.0-pl13.diff
make
make install INSTALL_ROOT=$1

cd $2

# http://www.openjpeg.org/
# http://www.openjpeg.org/index.php?menu=download
tar -xvzf $3/openjpeg_v1_3.tar.gz
cd "OpenJPEG_v1_3"
patch -p1 < $4/OpenJPEG_v1_3.diff
make
make install PREFIX=$1

cd  $2

# svn checkout svn://svn.mplayerhq.hu/ffmpeg/branches/0.5 ffmpeg-0.5 
# archive is self made
tar -xvjf $3/ffmpeg-0.5-r19118.tar.bz2
cd "ffmpeg-0.5"
# http://oss.netfarm.it/mplayer/misc/ffmpeg_ptw32_static.diff
patch -p0 < $4/ffmpeg_ptw32_static.diff
patch -p1 < $4/ffmpeg-0.5.diff
./configure --prefix=$1 --disable-shared --enable-memalign-hack --enable-nonfree --enable-pthreads --enable-bzlib --enable-libamr-nb --enable-libamr-wb --enable-libfaac --enable-libfaad --enable-libmp3lame --enable-libnut --enable-libdirac --enable-libschroedinger --enable-libspeex --enable-libtheora --enable-libvorbis --enable-gpl --enable-libx264 --enable-libxvid --enable-zlib --enable-libopenjpeg --enable-libgsm --enable-postproc --enable-swscale --enable-avfilter --enable-vhook --enable-avfilter-lavf --extra-cflags="-I$1/include -DLIBTWOLAME_STATIC -fno-common"
make
make install

cd $2 
